#ifndef INCLUDEHOTSEATGAMEGAMEPROPERTIES_H
#define INCLUDEHOTSEATGAMEGAMEPROPERTIES_H


struct GameProperties
{
public:
    /*
     * RACES_MAXNUM - количество рас.
     * Не должно превосходить количество QLabel available_race_*
     * элементов графического интерфейса сцены
     */

    static constexpr unsigned RACES_MAXNUM = 2;

    /*
     * AVAILABLE_UNIT_MAXNUM - максимальное количество доступных юнитов для расы.
     * Не должно превосходить количества QLable available_unit_* элементов
     * графического интерфейса сцены
     */

    static constexpr unsigned AVAILABLE_UNIT_MAXNUM = 5;

    /*
     * MAX_PARTY_SIZE - максимальное количество юнитов в отряде.
     * Не должно превосходить количества QLable chosen_unit* элементов
     * графического интерфейса сцены.
     */

    static constexpr unsigned MAX_PARTY_SIZE = 7;

    /*
     * PLAYERS_NUMBER - количество игроков, участвующих в сценарии.
     */

    static const unsigned PLAYERS_NUMBER = 2;

    /*
     * FIELD_ROWS_NUMBER - количество строк из шестиугольников на игровом поле
     */

    static unsigned FIELD_ROWS_NUMBER;

    /*
     * FIELD_COLUMNS_NUMBER - количество столбцов из шестиугольников на игровом поле
     */

    static unsigned FIELD_COLUMNS_NUMBER;

    /*
     * CELL_MIN_RADIUS - минимальное из расстояний от центра игровой клетки до её границ.
     */

    static double CELL_MIN_RADIUS;


    /*
     * CELL_MAX_RADIUS - максимальное из расстояний от центра игровой клетки до её границ.
     */

    static double CELL_MAX_RADIUS;
};


#endif // INCLUDEHOTSEATGAMEGAMEPROPERTIES_H
